# Pantalaimon UT

End-to-end encryption aware Matrix reverse proxy daemon for Ubuntu Touch.

[source code](https://git.sr.ht/~thrrgilag/pantalaimon-ut) -
[issue tracker](https://todo.sr.ht/~thrrgilag/pantalaimon-ut) -
[mailing list](https://lists.sr.ht/~thrrgilag/pantalaimon-ut) -
[releases](https://git.sr.ht/~thrrgilag/pantalaimon-ut/refs)

## TODO

- [x] About page
- [x] App icon
- [x] Fix image fetching (fixed in fluffychat)
- [x] Cross compile python+pantalaimon
- [-] Import/export keys
- [-] Ability to verify, ignore, or blacklist devices

## Known Issues

- Previously encrypted messages may not be decrypted

## panctl

The ability to verify, ignore, or blacklist devices is currently limited to the use of the panctl utility which can be accessed using the Terminal app by running `/opt/click.ubuntu.com/pantalaimon.thrrgilag/current/panctl`. See the [man](https://github.com/matrix-org/pantalaimon/blob/master/docs/man/panctl.md) for details on how to use it.

## Build pantalaimon and panctl

The background daemon (pantalaimon) and shell utility (panctl) are built directly on device due to complications with cross compiling dependencies. You'll need a device with sufficient space free on the system partition to install all of the required packages. For the most recent release I utilized a Raspberry Pi 4 to create the binaries for arm64 and armhf.

1. Put the dev-build.sh script in /home/phablet on the target device and execute `./dev-build.sh`
2. Pull the ~/pantalaimon-build/dist/pantalaimon and ~/pantalaimon-build/dist/panctl to your local source tree
3. Rename the files to add -{ARCH} *(e.g. mv pantalaimon pantalaimon-arm64)*

## Build click package

- Install or update [clickable](https://clickable-ut.dev/en/latest/install.html)
- For ARM64 devices run `clickable --arch=arm64`
- For ARMHF devices run `clickable --arch=armhf`

## Contributing

Report bugs or send patches to
[~thrrgilag/pantalaimon-ut@lists.sr.ht](https://lists.sr.ht/~thrrgilag/pantalaimon-ut).

A tutorial for git send-email can be found at [git-send-email.io](https://git-send-email.io/) 
if you're not familiar with this method.

You can also join my public chat room at [#dev:thrrgilag.ems.host](https://matrix.to/#/#dev:thrrgilag.ems.host) or [dev@conference.dreamfall.space](xmpp:dev@conference.dreamfall.space?join) (*xmpp*).

## License

Copyright (C) 2021  Morgan McMillian

Licensed under the Apache Software License 2.0
